{*************************+********************************}
{*                                                        *}
{*   Nazov: Buttons Unit                                  *}
{*   Datum:  6.10.2001                                    *}
{*   Start: 26. 9.2001                                    *}
{*   Jazyk: Turbo Pascal 7.0                              *}
{*   Autor: Milsoft                                       *}
{*   Typ:   Unit                                          *}
{*                                                        *}
{**********************************************************}

{$F-,O-,A+,G+,R+,S-,I-,Q+,V+,B-,X+,T+,P-,D-,L-,Y-,N-,E-}

unit buttons;

interface

procedure buttonoff(x1,y1,x2,y2: integer; s: string; c: byte);
procedure buttonon(x1,y1,x2,y2: integer; s: string);
function buttonover(x1,y1,x2,y2,x,y: integer): boolean;

implementation

uses crt,graph;

procedure buttonoff(x1,y1,x2,y2: integer; s: string; c: byte);
var
  i,j: byte;
begin
  setfillstyle(solidfill,lightgray);
  bar(x1 + 1,y1 + 1,x2 - 1,y2 - 1);
  setcolor(white);
  for i := 0 to 1 do line(x1 + i,y1 + i,x2 - i,y1 + i);
  for i := 0 to 1 do line(x1 + i,y1 + i,x1 + i,y2 - i);
  setcolor(darkgray);
  for i := 0 to 1 do line(x2 - i,y1 + i,x2 - i,y2 - i);
  for i := 0 to 1 do line(x1 + i,y2 - i,x2 - i,y2 - i);
  j := pos('-',s);
  settextstyle(smallfont,horizdir,6);
  setcolor(c);
  settextjustify(lefttext,centertext);
  outtextxy(x1 + 10,(y1 + y2) div 2 - 3,copy(s,1,j - 1));
  outtextxy(x1 + 11,(y1 + y2) div 2 - 3,copy(s,1,j - 1));
  settextjustify(righttext,centertext);
  outtextxy(x2 - 11,(y1 + y2) div 2 - 3,copy(s,j + 1,length(s) - j));
  outtextxy(x2 - 10,(y1 + y2) div 2 - 3,copy(s,j + 1,length(s) - j));
end;

procedure buttonon(x1,y1,x2,y2: integer; s: string);
var
  i,j: byte;
begin
  setfillstyle(solidfill,lightgray);
  bar(x1 + 1,y1 + 1,x2 - 1,y2 - 1);
  setcolor(darkgray);
  for i := 0 to 1 do line(x1 + i,y1 + i,x2 - i,y1 + i);
  for i := 0 to 1 do line(x1 + i,y1 + i,x1 + i,y2 - i);
  setcolor(white);
  for i := 0 to 1 do line(x2 - i,y1 + i,x2 - i,y2 - i);
  for i := 0 to 1 do line(x1 + i,y2 - i,x2 - i,y2 - i);
  j := pos('-',s);
  settextstyle(smallfont,horizdir,6);
  setcolor(black);
  settextjustify(lefttext,centertext);
  outtextxy(x1 + 10,(y1 + y2) div 2 - 3,copy(s,1,j - 1));
  outtextxy(x1 + 11,(y1 + y2) div 2 - 3,copy(s,1,j - 1));
  settextjustify(righttext,centertext);
  outtextxy(x2 - 11,(y1 + y2) div 2 - 3,copy(s,j + 1,length(s) - j));
  outtextxy(x2 - 10,(y1 + y2) div 2 - 3,copy(s,j + 1,length(s) - j));
end;

function buttonover(x1,y1,x2,y2,x,y: integer): boolean;
begin
  if (x >= x1) and (x <= x2) and (y >= y1) and (y <= y2) then
    buttonover := true
  else
    buttonover := false;
end;

end.
