{**********************************************************}
{*                                                        *}
{*   Nazov:  Wurmi                                        *}
{*   Verzia: 3.01 beta                                    *}
{*   Datum:   9. 6.2002                                   *}
{*   Start:  12. 8.2000                                   *}
{*   Jazyk:  Turbo Pascal 7.0                             *}
{*   Autor:  Milsoft                                      *}
{*   Typ:    Software                                     *}
{*                                                        *}
{**********************************************************}

{$define COMPILEa}

{$ifdef COMPILE}
  {$F-,O-,A+,G+,R-,S-,I-,Q-,V+,B-,X+,T+,P-,D-,L-,Y-,N-,E-}
{$else}
  {$F-,O-,A+,G+,R+,S+,I-,Q+,V+,B-,X+,T+,P-,D+,L+,Y+,N-,E-}
{$endif}
program Wurmi;
uses crt,dos,graph,agraph,bgidriv,bgiskfnt,pause,mouse,viruses,
  utility,inifile,milsoft,buttons,texts;
type
  image1 = array[1..134] of byte;           {typ pre grafiku 16x16}
  image2 = array[1..38] of byte;            {typ pre grafiku 8x8}
const
  pname  = 'Wurmi';                         {nazov programu}
  pvers  = '3.01 beta';                     {verzia programu}
  pcopy  = '(C) Milsoft';                   {copyright}
  pdate  = '9.6.2002';                      {datum vytvorenia}
  pdate0 = '9. jn 2002';                   {datum vytvorenia}
  fprot  = 'WURMI.DAT';                     {ochrana proti kopirovaniu}
  fini   = 'WURMI.INI';                     {inicializacny subor}
  fhelp  = 'WURMI.INF';                     {pomoc}
  fstat  = 'WURMI.STA';                     {statistika}
  ftop   = 'WURMI.TOP';                     {tabulka najlepsich}
  fplay1 = 'WURMI1.LST';                    {zoznam hracov malej hry}
  fplay2 = 'WURMI2.LST';                    {zoznam hracov velkej hry}
  wmax   = 2400;                            {max. dlzka Wurmiho}
  pmax   = 99;                              {max. pocet hracov}
  tmax   = 50;                              {max. pocet hracov v tab. najlep.}
  clen   = 9;                               {farba dlzky}
  ctim   = 10;                              {farba casu}
  maxx1  = 31;                              {max. sirka malej hry}
  maxy1  = 29;                              {max. vyska malej hry}
  ndie1  = 40;                              {pocet otrav malej hry}
  neat1  = 70;                              {pocet kapusticiek malej hry}
  wtime1 = 300;                             {cas malej hry}
  maxx2  = 63;                              {max. sirka velkej hry}
  maxy2  = 59;                              {max. vyska velkej hry}
  ndie2  = 171;                             {pocet otrav velkej hry}
  neat2  = 300;                             {pocet kapusticiek velkej hry}
  wtime2 = 1200;                            {cas velkej hry}
  free   = 0;                               {obr. prazdny}
  head   = 1;                               {obr. hlavy}
  body   = 2;                               {obr. tela}
  wall   = 3;                               {obr. steny}
  die    = 4;                               {obr. otravy}
  eat    = 5;                               {obr. kapusticky}
  img1: array[0..5] of image1 = (           {grafika 16x16}
    ($0F,$00,$0F,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
     $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
     $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
     $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
     $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
     $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
     $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
     $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
     $00,$00,$00,$00,$00,$00),
    ($0F,$00,$0F,$00,$03,$C0,$03,$C0,$03,$C0,$03,$C0,$0F,$F0,$0F,$F0,
     $0F,$F0,$0F,$F0,$1F,$F8,$1F,$F8,$1F,$F8,$1F,$F8,$3B,$DC,$3B,$DC,
     $3B,$DC,$3B,$DC,$71,$8E,$71,$8E,$71,$8E,$71,$8E,$71,$8E,$71,$8E,
     $71,$8E,$71,$8E,$FB,$DF,$FB,$DF,$FB,$DF,$FB,$DF,$FF,$FF,$FF,$FF,
     $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$F3,$CF,$F3,$CF,
     $F3,$CF,$F3,$CF,$71,$8E,$71,$8E,$71,$8E,$71,$8E,$78,$1E,$78,$1E,
     $78,$1E,$78,$1E,$3C,$3C,$3C,$3C,$3C,$3C,$3C,$3C,$1F,$F8,$1F,$F8,
     $1F,$F8,$1F,$F8,$0F,$F0,$0F,$F0,$0F,$F0,$0F,$F0,$03,$C0,$03,$C0,
     $03,$C0,$03,$C0,$00,$00),
    ($0F,$00,$0F,$00,$00,$00,$00,$00,$00,$00,$00,$00,$03,$C0,$03,$C0,
     $03,$C0,$00,$00,$0F,$F0,$0F,$F0,$0F,$F0,$00,$00,$1F,$F8,$1F,$F8,
     $1F,$F8,$00,$00,$3F,$FC,$3F,$FC,$3F,$FC,$00,$00,$3F,$FC,$3F,$FC,
     $3F,$FC,$00,$00,$7F,$FE,$7F,$FE,$7F,$FE,$00,$00,$7F,$FE,$7F,$FE,
     $7F,$FE,$00,$00,$7F,$FE,$7F,$FE,$7F,$FE,$00,$00,$7F,$FE,$7F,$FE,
     $7F,$FE,$00,$00,$3F,$FC,$3F,$FC,$3F,$FC,$00,$00,$3F,$FC,$3F,$FC,
     $3F,$FC,$00,$00,$1F,$F8,$1F,$F8,$1F,$F8,$00,$00,$0F,$F0,$0F,$F0,
     $0F,$F0,$00,$00,$03,$C0,$03,$C0,$03,$C0,$00,$00,$00,$00,$00,$00,
     $00,$00,$00,$00,$00,$00),
    ($0F,$00,$0F,$00,$00,$00,$00,$00,$00,$00,$67,$E6,$00,$00,$00,$00,
     $00,$00,$E7,$E7,$00,$00,$00,$00,$00,$00,$CF,$F3,$00,$00,$00,$00,
     $00,$00,$1E,$78,$00,$00,$00,$00,$00,$00,$3C,$3C,$00,$00,$00,$00,
     $00,$00,$F9,$9F,$00,$00,$00,$00,$00,$00,$F3,$CF,$00,$00,$00,$00,
     $00,$00,$E6,$67,$00,$00,$00,$00,$00,$00,$E6,$67,$00,$00,$00,$00,
     $00,$00,$F3,$CF,$00,$00,$00,$00,$00,$00,$F9,$9F,$00,$00,$00,$00,
     $00,$00,$3C,$3C,$00,$00,$00,$00,$00,$00,$1E,$78,$00,$00,$00,$00,
     $00,$00,$CF,$F3,$00,$00,$00,$00,$00,$00,$E7,$E7,$00,$00,$00,$00,
     $00,$00,$67,$E6,$00,$00),
    ($0F,$00,$0F,$00,$00,$00,$3F,$FC,$3F,$FC,$00,$00,$00,$00,$7F,$FE,
     $7F,$FE,$00,$00,$00,$00,$FF,$FF,$FF,$FF,$00,$00,$00,$00,$ED,$B7,
     $ED,$B7,$00,$00,$00,$00,$F3,$CF,$F3,$CF,$00,$00,$00,$00,$F3,$CF,
     $F3,$CF,$00,$00,$00,$00,$ED,$B7,$ED,$B7,$00,$00,$00,$00,$FE,$7F,
     $FE,$7F,$00,$00,$00,$00,$FE,$7F,$FE,$7F,$00,$00,$00,$00,$ED,$B7,
     $ED,$B7,$00,$00,$00,$00,$F3,$CF,$F3,$CF,$00,$00,$00,$00,$F3,$CF,
     $F3,$CF,$00,$00,$00,$00,$ED,$B7,$ED,$B7,$00,$00,$00,$00,$FF,$FF,
     $FF,$FF,$00,$00,$00,$00,$7F,$FE,$7F,$FE,$00,$00,$00,$00,$3F,$FC,
     $3F,$FC,$00,$00,$00,$00),
    ($0F,$00,$0F,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
     $03,$C0,$00,$00,$00,$00,$00,$00,$07,$E0,$00,$00,$00,$00,$00,$00,
     $07,$E0,$00,$00,$00,$00,$00,$00,$07,$E0,$00,$00,$00,$00,$00,$00,
     $3B,$DC,$00,$00,$00,$00,$00,$00,$7D,$BE,$00,$00,$00,$00,$00,$00,
     $7F,$FE,$00,$00,$00,$00,$00,$00,$7F,$FE,$00,$00,$00,$00,$00,$00,
     $7D,$BE,$00,$00,$00,$00,$00,$00,$39,$9C,$00,$00,$00,$00,$00,$00,
     $01,$80,$00,$00,$00,$00,$00,$00,$01,$80,$00,$00,$00,$00,$00,$00,
     $03,$C0,$00,$00,$00,$00,$00,$00,$03,$C0,$00,$00,$00,$00,$00,$00,
     $00,$00,$00,$00,$00,$00));
  img2: array[0..5] of image2 = (           {grafika 8x8}
    ($07,$00,$07,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
     $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
     $00,$00,$00,$00,$00,$00),
    ($07,$00,$07,$00,$3C,$3C,$3C,$3C,$7E,$7E,$7E,$7E,$DB,$DB,$DB,$DB,
     $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$DB,$DB,$DB,$DB,$66,$66,$66,$66,
     $3C,$3C,$3C,$3C,$00,$00),
    ($07,$00,$07,$00,$00,$00,$00,$00,$3C,$3C,$3C,$00,$7E,$7E,$7E,$00,
     $7E,$7E,$7E,$00,$7E,$7E,$7E,$00,$7E,$7E,$7E,$00,$3C,$3C,$3C,$00,
     $00,$00,$00,$00,$00,$00),
    ($07,$00,$07,$00,$00,$00,$00,$DB,$00,$00,$00,$E7,$00,$00,$00,$7E,
     $00,$00,$00,$BD,$00,$00,$00,$BD,$00,$00,$00,$7E,$00,$00,$00,$E7,
     $00,$00,$00,$DB,$00,$00),
    ($07,$00,$07,$00,$00,$7E,$7E,$00,$00,$FF,$FF,$00,$00,$DB,$DB,$00,
     $00,$E7,$E7,$00,$00,$E7,$E7,$00,$00,$DB,$DB,$00,$00,$FF,$FF,$00,
     $00,$7E,$7E,$00,$00,$00),
    ($07,$00,$07,$00,$00,$00,$00,$00,$00,$00,$3C,$00,$00,$00,$5A,$00,
     $00,$00,$7E,$00,$00,$00,$7E,$00,$00,$00,$5A,$00,$00,$00,$18,$00,
     $00,$00,$00,$00,$00,$00));
type
  tgarden     = array[0..63,0..59] of byte; {typ pre hracie pole}
  pstatistics = ^tstatistics;
  tstatistics = record                      {typ pre statistiku}
    time:  longint;
    micro: boolean;
    num:   byte;
    len:   word;
    next:  pstatistics;
  end;
  ttop = record
    time:  longint;
    num:   byte;
    len:   word;
  end;
const
  delay0: real = 1;                         {konstanta pre delay}
  rgb: array[0..15] of trgbpal =            {paleta hry}
  (
    ( 0,  0,  0),                           {cierna}
    ( 0,  0, 42),                           {modra}
    ( 0, 42,  0),                           {zelena}
    ( 0, 42, 42),                           {belasa}
    (42,  0,  0),                           {cervena}
    (42,  0, 42),                           {fialova}
    (35, 21,  0),                           {hneda}
    (42, 42, 42),                           {svetloseda}
    (21, 21, 21),                           {tmavoseda}
    (21, 21, 63),                           {svetlomodra}
    (21, 63, 21),                           {svetlozelena}
    (21, 63, 63),                           {svetlobelasa}
    (63, 21, 21),                           {svetlocervena}
    (63, 21, 63),                           {svetlofialova}
    (63, 63, 21),                           {zlta}
    (63, 63, 63)                            {biela}
  );
var
  svga:   integer;                          {ovladac svga256}
  vesa:   boolean;                          {pritomnost VESA SVGA karty a/n}
  clock:  longint absolute 0:$46c;          {casovac}
  pal:    palettetype;                      {paleta hry}
  ms:     boolean;                          {pripojena mys ano/nie}
  dir:    string;                           {adresar s hrou}
  garden: tgarden;                          {hracie pole}
  wx:     array[0..wmax] of byte;           {x sur. clankov tela Wurmiho}
  wy:     array[0..wmax] of byte;           {y sur. clankov tela Wurmiho}
  w0,w1:  word;                             {indexy zaciatku a konca tela}
  wl:     word;                             {dlzka Wurmiho}
  wt:     word;                             {zostavajuci cas}
  pw:     array[1..pmax] of longint;        {sucet dlzok za vsetky hry}
  pg:     array[1..pmax] of word;           {pocet vsetkych hier}
  pc:     byte;                             {pocet hracov}
  pn:     array[1..pmax] of string[30];     {mena hracov}
  pl:     array[1..pmax] of word;           {dlzky hracov}
  pp:     array[1..pmax] of string[30];     {hesla hracov}
  ps,px:  byte;                             {indexy na zobrazenie hracov}
  pl0:    word;                             {maximalna dosiahnuta dlzka v hre}
  sndflg: boolean;                          {zvuk zap/vyp}
  micro:  boolean;                          {mikro hra ano/nie}
  maxx:   byte;                             {max. sirka aktual. hry}
  maxy:   byte;                             {max. vyska aktual. hry}
  ndie:   word;                             {pocet otrav aktual. hry}
  neat:   word;                             {pocet kapusticiek aktual. hry}
  wtime:  word;                             {cas aktual. hry}
  fplay:  string[12];                       {nazov suboru s hracmi}
  size:   byte;                             {velkost pisma}
  wtype:  string[6];                        {typ hry}
  stat0:  pstatistics;                      {zaciatok pola pre statistiku}
  stat1:  pstatistics;                      {pomocna premenna pre statistiku}
  top:    array[boolean,1..tmax] of ttop;   {tabulka najlepsich}
  topmic: boolean;                          {aktualny rekord, typ try}
  topact: byte;                             {aktualny rekord v tab. naj.}
  saver0: longint;                          {cas posledneho pohybu pre setric}
  saver1: longint;                          {aktualny cas pre setric}
  saver:  boolean;                          {spusteny setric a/n}
  ms_x0:  integer;                          {posledna x sur. mysi pre setric}
  ms_y0:  integer;                          {posledna y sur. mysi pre setric}
  gd,gm:  integer;                          {hodnoty pre graficky ovladac}

procedure snd(hz: word; w: word);           {zvuk}
begin
  if sndflg then sound(hz);
  delay(trunc(w * delay0));
  nosound;
end;

procedure showhelp;                         {zobrazenie napovedy}
begin
  writeln;
  writeln(pname + ' ' + pvers + '   ' + pcopy + '   ' + pdate);
  writeln;
  writeln('Program sa da spustit s parametrami:');
  writeln;
  writeln('WURMI [/?] | [S[+|-]] [M[+|-]]');
  writeln;
  writeln('/?     - vypisanie tejto napovedy');
  writeln('S[+|-] - zapnutie / vypnutie zvuku');
  writeln('M[+|-] - zapnutie / vypnutie typu hry Mikro');
  writeln;
  halt;
end;

procedure halterror(b: byte);               {koniec programu s chybou}
begin
  case b of
    1: writeln('Nekompletna instalacia, prosim preinstalovat.');
    2: writeln('Subor WURMI.EXE je poskodeny.');
    3: writeln('Program vyzaduje minimalne graficky mod EGA 640x350x16.');
  end;
  halt(1);
end;

procedure readplayers;                      {nacitanie hracov}
var
  f:   file;
  i,j: byte;
  w:   word;
  b:   boolean;
begin
  px := 1;
  b := false;
  assign(f,dir + '\' + fplay);
  reset(f,1);
  if ioresult <> 0 then
    b := true
  else
    begin
      blockread(f,pc,sizeof(pc),w);
      if w <> sizeof(pc) then b := true;
      if pc > 0 then
        for i := 1 to pc do
          begin
            blockread(f,pn[i],sizeof(pn[i]),w);
            if w <> sizeof(pn[i]) then b := true;
            blockread(f,pl[i],sizeof(pl[i]),w);
            if w <> sizeof(pl[i]) then b := true;
            for j := 1 to length(pn[i]) do
              pn[i,j] := chr(byte(pn[i,j]) xor $ff);
            pp[i] := '';
          end;
      ps := 1;
      while not eof(f) do
        begin
          blockread(f,i,sizeof(i),w);
          if w <> sizeof(i) then b := true;
          blockread(f,pp[i],sizeof(pp[i]),w);
          if w <> sizeof(pp[i]) then b := true;
          for j := 1 to length(pp[i]) do
            pp[i,j] := chr(byte(pp[i,j]) xor $ff);
        end;
      close(f);
    end;
  if b then pc := 0;
  if pc = 0 then ps := 0;
end;

procedure writeplayers;                     {ulozenie hracov}
var
  f:   file;
  i,j: byte;
  w:   word;
  b:   boolean;
begin
  b := false;
  assign(f,dir + '\' + fplay);
  rewrite(f,1);
  if ioresult = 0 then
    begin
      blockwrite(f,pc,sizeof(pc),w);
      if w <> sizeof(pc) then b := true;
      if pc > 0 then
        for i := 1 to pc do
          begin
            for j := 1 to sizeof(pn[i]) - 1 do
              if j <= length(pn[i]) then
                pn[i,j] := chr(byte(pn[i,j]) xor $FF)
              else
                pn[i,j] := #0;
            blockwrite(f,pn[i],sizeof(pn[i]),w);
            if w <> sizeof(pn[i]) then b := true;
            blockwrite(f,pl[i],sizeof(pl[i]),w);
            if w <> sizeof(pl[i]) then b := true;
          end;
        for i := 1 to pc do
          if pp[i] <> '' then
            begin
              for j := 1 to sizeof(pp[i]) - 1 do
                if j <= length(pp[i]) then
                  pp[i,j] := chr(byte(pp[i,j]) xor $FF)
                else
                  pp[i,j] := #0;
              blockwrite(f,i,sizeof(i),w);
              if w <> sizeof(i) then b := true;
              blockwrite(f,pp[i],sizeof(pp[i]),w);
              if w <> sizeof(pp[i]) then b := true;
            end;
      if b then
        erase(f)
      else
        close(f);
    end;
end;

function stattime(r,m,d,h,n: longint): longint;
begin
  if m < 3 then
    begin
      dec(r);
      inc(m,13);
    end
  else
    inc(m);
  stattime := ((r * 365) + (r div 4) - (r div 100) + (r div 400)
              + trunc(m * 30.6) + d - 694024) * 1440 + h * 60 + n;
end;

function newstat(st: pstatistics; x: byte): boolean;
var
  r,m,d,t: word;
  h,n,s:   word;
  dt:      datetime;
  tmptime: longint;
begin
  getdate(r,m,d,t);
  gettime(h,n,s,t);
  unpacktime(st^.time,dt);
  newstat := false;
  case x of
    0: if stattime(r,m,d,0,0) <= stattime(dt.year,dt.month,dt.day,dt.hour,dt.
         min) then newstat := true;
    1: if stattime(r,m,d,h,n) - stattime(dt.year,dt.month,dt.day,dt.hour,dt.
         min) <= 24 * 60 then newstat := true;
    2: if stattime(r,m,d,h,n) - stattime(dt.year,dt.month,dt.day,dt.hour,dt.
         min) <= 7 * 24 * 60 then newstat := true;
    3: if stattime(r,m,d,h,n) - stattime(dt.year,dt.month,dt.day,dt.hour,dt.
         min) <= 30 * 7 * 24 * 60 then newstat := true;
  end;
end;

procedure readstatistics;
var
  f: file;
  w: word;
begin
  new(stat0);
  stat1 := stat0;
  assign(f,dir + '\' + fstat);
  reset(f,1);
  if ioresult = 0 then
    begin
      while not eof(f) do
        begin
          with stat1^ do
            begin
              blockread(f,time,sizeof(longint),w);
              blockread(f,micro,sizeof(boolean),w);
              blockread(f,num,sizeof(byte),w);
              blockread(f,len,sizeof(word),w);
              new(next);
            end;
          stat1 := stat1^.next;
        end;
      close(f);
    end;
  stat1^.next := nil;
end;

procedure writestatistics;
var
  f: file;
  w: word;
begin
  assign(f,dir + '\' + fstat);
  rewrite(f,1);
  stat1 := stat0^.next;
  while stat1 <> nil do
    begin
      if newstat(stat0,3) then
        with stat0^ do
          begin
            blockwrite(f,time,sizeof(longint),w);
            blockwrite(f,micro,sizeof(boolean),w);
            blockwrite(f,num,sizeof(byte),w);
            blockwrite(f,len,sizeof(word),w);
          end;
      dispose(stat0);
      stat0 := stat1;
      stat1 := stat0^.next;
    end;
  close(f);
  dispose(stat0);
end;

procedure statsort(i,j: byte);
begin
  stat1 := stat0;
  while stat1^.next <> nil do
    begin
      with stat1^ do
        if num in [i..j] then
          if num = j then
            num := i
          else
            inc(num);
      stat1 := stat1^.next;
    end;
end;

procedure statadd(m: boolean; n: byte; l: word);
var
  a,b,c,d: word;
  dt:      datetime;
begin
  getdate(a,b,c,d);
  with dt do
    begin
      year := a;
      month := b;
      day := c;
    end;
  gettime(a,b,c,d);
  with dt do
    begin
      hour := a;
      min := b;
      sec := c;
    end;
  with stat1^ do
    begin
      packtime(dt,time);
      micro := m;
      num := n;
      len := l;
      new(next);
    end;
  stat1 := stat1^.next;
  stat1^.next := nil;
end;

procedure statdel(i: byte);                 {vymazanie hraca zo statistiky}
var
  statx: ^tstatistics;                      {posledny nevymzany hrac}
  stat2: ^tstatistics;                      {nasledujuci hrac}
begin
  stat1 := stat0;
  statx := nil;
  while stat1^.next <> nil do
    begin
      stat2 := stat1^.next;
      with stat1^ do
        if num in [i..pmax] then
          if num = i then
            begin
              dispose(stat1);
              if statx = nil then
                stat0 := stat2
              else
                statx^.next := stat2;
            end
          else
            begin
              dec(num);
              statx := stat1;
            end
        else
          statx := stat1;
      stat1 := stat2;
    end;
end;

procedure statcomp(x: byte);
var
  i: byte;
begin
  for i := 1 to pmax do
    begin
      pw[i] := 0;
      pg[i] := 0;
    end;
  stat1 := stat0;
  while stat1^.next <> nil do
    begin
      if (stat1^.micro = micro) and newstat(stat1,x) then
        with stat1^ do
          begin
            inc(pw[num],len);
            inc(pg[num]);
          end;
      stat1 := stat1^.next;
    end;
end;

procedure readtop;                          {nacitanie tabulky najlepsich}
var
  f: file;
  w: word;
begin
  assign(f,dir + '\' + ftop);
  reset(f,1);
  if ioresult = 0 then
    begin
      blockread(f,top,sizeof(top),w);
      close(f);
      if w <> sizeof(top) then
        fillchar(top,sizeof(top),#0);
    end;
  topact := 0;
end;

procedure writetop;                         {ulozenie tabulky najlepsich}
var
  f: file;
  w: word;
begin
  assign(f,dir + '\' + ftop);
  rewrite(f,1);
  if ioresult = 0 then
    begin
      blockwrite(f,top,sizeof(top),w);
      close(f);
      if w <> sizeof(top) then erase(f);
    end;
end;

procedure topsort(m,n: byte);
var
  i: byte;
begin
  i := 1;
  while (i <= tmax) and (top[micro,i].num > 0) do
    begin
      with top[micro,i] do
        if num in [m..n] then
          if num = n then
            num := m
          else
            inc(num);
      inc(i);
    end;
end;

procedure topadd(m: boolean; n: byte; l: word);{pridanie rekkordu do tabulky}
var
  i,j:     byte;
  a,b,c,d: word;
  dt:      datetime;
begin
  j := tmax + 1;
  if l > 0 then
    while (j > 1) and ((top[m,j - 1].num = 0) or (top[m,j - 1].len < l)) do
      dec(j);
  topmic := m;
  topact := j;
  if j <= tmax then
    begin
      if j < tmax then
        for i := tmax - 1 downto j do
          if top[m,i].num > 0 then top[m,i + 1] := top[m,i];
      with top[m,j] do
        begin
          getdate(a,b,c,d);
          with dt do
            begin
              year := a;
              month := b;
              day := c;
            end;
          gettime(a,b,c,d);
          with dt do
            begin
              hour := a;
              min := b;
              sec := c;
            end;
          packtime(dt,time);
          num := n;
          len := l;
        end;
    end;
end;

procedure topdel(n: byte);                  {vymazanie hraca z tabulky}
var
  i,j: byte;
begin
  topact := 0;
  i := 1;
  j := 1;
  while i <= tmax do
    begin
      while (j <= tmax) and (top[micro,j].num = n) do inc(j);
      if (j <= tmax) and (top[micro,j].num = 0) then j := tmax + 1;
      if j <= tmax then
        begin
          top[micro,i] := top[micro,j];
          if top[micro,i].num > n then dec(top[micro,i].num);
        end
      else
        fillchar(top[micro,i],sizeof(top[micro,i]),#0);
      inc(i);
      if j <= tmax then inc(j);
    end;
end;

procedure microwurmi(b: boolean);
begin
  micro := b;
  if not micro then
    begin
      maxx := maxx1;
      maxy := maxy1;
      ndie := ndie1;
      neat := neat1;
      wtime := wtime1;
      fplay := fplay1;
      size := 6;
      wtype := '';
    end
  else
    begin
      maxx := maxx2;
      maxy := maxy2;
      ndie := ndie2;
      neat := neat2;
      wtime := wtime2;
      fplay := fplay2;
      size := 5;
      wtype := 'Micro ';
    end;
  readplayers;
end;

procedure initpalette;                      {inicializacia palety}
var
  i: integer;
begin
  cleardevice;
  if gd = ega then exit;
  for i := 0 to 15 do
    setrgbpal(pal.colors[i],rgb[i,0],rgb[i,1],rgb[i,2]);
end;

procedure donepalette;                      {zhasnutie palety}
var
  i: byte;
begin
  if gd = ega then exit;
  for i := 0 to 15 do rgbtopal(rgb,i,0,0,0);
  fadepal(rgb,0,15,15);
end;

procedure init;                             {inicializacia}

  procedure checktimeroutine;                 {kontrola casovych rutin}
  var
    h,m,s,t: word;
    t0:      word;

    procedure computedelay;                   {vypocitanie casoveho zdrazania}
    var
      i: word;
    begin
      i := 0;
      gettime(h,m,s,t);
      repeat
        gettime(h,m,s,t0);
      until t0 <> t;
      repeat
        delay(1);
        inc(i);
        gettime(h,m,s,t);
      until t <> t0;
      delay0 := i / 55;
    end;

  begin
    gettime(h,m,s,t);
    repeat
      gettime(h,m,s,t0);
    until t0 <> t;
    delay(54);
    gettime(h,m,s,t);
    if t <> t0 then computedelay;
    delay(1);
    gettime(h,m,s,t);
    if t = t0 then computedelay;
  end;

  procedure checkforviruses;
  var
    virus: boolean;
    c:     char;
  begin
    virus := false;
    if happyend then
      begin
        writeln;
        writeln('Virus HappyEnd bol najdeny v pamati.');
        virus := true;
      end;
    if virus then
      begin
        writeln;
        writeln('Enter - Spustenie programu');
        writeln('Esc   - Ukoncenie programu');
        writeln('R     - Restart pocitaca');
        repeat
          c := upcase(readkey);
        until c in [#13,#27,'R'];
        case c of
          #27: halt(1);
          'R':
            asm
              xor  ax,ax
              mov  ds,ax
              mov  word ptr ds:[$472],$1234
              push $ffff
              push $0000
              retf
            end;
        end;
      end;
  end;

  procedure checkfile(name: string);
  var
    f: file;
  begin
    assign(f,dir + '\' + name);
    reset(f,1);
    if ioresult <> 0 then halterror(1);
    close(f);
  end;

  function getvesamode(var vesamode: array of byte; mode: word): boolean;
    assembler;
  asm
    mov ax,$4f01
    mov cx,mode
    les di,[vesamode]
    int $10
    cmp al,$4f
    jne @1
    cmp ah,0
    jne @1
    mov al,1
    jmp @2
  @1:
    mov al,0
  @2:
  end;

  procedure config;                           {nastavenie konfiguracie}
  var
    b,n,v: string31;
    s:     string;
    i:     word;
  begin
    resetini(dir + '\' + fini);
    if inierror = ini_ok then
      while not endofini do
        begin
          readseqvalue(b,n,v);
          if inierror = ini_ok then
            if ucase(b) = 'MAIN' then
              begin
                n := ucase(n);
                if n = 'SOUND' then sndflg := v[1] = '1';
                if n = 'MICRO' then micro := v[1] = '1';
              end;
        end;
    if inierror <> ini_ok then
      begin
        sndflg := true;
        micro := false;
      end;
    for i := 1 to paramcount do
      begin
        s := ucase(paramstr(i));
        if s = 'S-' then sndflg := false;
        if s = 'S+' then sndflg := true;
        if s = 'M-' then micro := false;
        if s = 'M+' then micro := true;
      end;
  end;

  procedure graphicsinit;                     {inicializacia grafiky}
  var
    buf:   array[0..255] of byte;
  begin
    detectgraph(gd,gm);
    gd := ega;
    gm := 1;
    if not (gd in [ega,vga]) then halterror(3);
    if (gd = vga) and (getvesamode(buf,$101) and (buf[0] and 1 = 1)) then
      begin
        vesa := true;
        svga := installuserdriver('SVGA256',nil);
        if registerbgidriver(@svga256driverproc) < 0 then halterror(2);
      end
    else
      vesa := false;
    if registerbgidriver(@egavgadriverproc) < 0 then halterror(2);
    if (registerbgifont(@triplexfontskproc) < 0) or
      (registerbgifont(@smallfontskproc) < 0) or
      (registerbgifont(@triplexscriptfontskproc) < 0) or
      (registerbgifont(@complexfontskproc) < 0) then halterror(2);
    initgraph(gd,gm,dir);
    if graphresult <> 0 then halterror(2);
    scale(0,0,639,479);
    getpalette(pal);
    initpalette;
  end;

begin
  checkbreak := false;
  nosound;
  checkforviruses;
  getprgdir(dir);
  {$ifdef COMPILE}
  {$else}
  dir:='d:\tp\pas\done\wurmi';
  {$endif}
  checkfile(fhelp);
  if paramstr(1) = '/?' then showhelp;
  graphicsinit;
  ms := mouseinit;
  if gd = vga then
    mouseset(320,240)
  else
    mouseset(320,175);
  setkeyspeed(0,0);
  checktimeroutine;
  config;
  microwurmi(micro);
  readstatistics;
  readtop;
  randomize;
end;

function maketime(t: word): string;         {premena sekund na MM:SS}
var
  s: string;
begin
  s := strng(t div 60,1);
  t := t mod 60;
  s := s + ':';
  if t < 10 then s := s + '0';
  s := s + strng(t,1);
  maketime := s;
end;

function maketimehms(h,m,s: word): string;
var
  t: string;
begin
  t := strng(h,1);
  if h < 10 then t := '0' + t;
  t := t + ':';
  if m < 10 then t := t + '0';
  t := t + strng(m,1);
  t := t + ':';
  if s < 10 then t := t + '0';
  t := t + strng(s,1);
  maketimehms := t;
end;

function maketimehm(h,m: word): string;
var
  t: string;
begin
  t := strng(h,1);
  if h < 10 then t := '0' + t;
  t := t + ':';
  if m < 10 then t := t + '0';
  t := t + strng(m,1);
  maketimehm := t;
end;

function makedate: string;                  {premena datumu na text}
const
  mm: array[1..12] of string[9] =
        ('janur','februr','marec','aprl','mj','jn',
         'jl','august','september','oktber','november','december');
  tt: array[0..6] of string[8] =
        ('nedea','pondelok','utorok','streda','tvrtok','piatok','sobota');
var
  r,m,d,t: word;
begin
  getdate(r,m,d,t);
  makedate := tt[t] + ' ' + strng(d,1) + '. ' + mm[m] + ' ' + strng(r,1);
end;

function makedateshort(d,m,r: word): string;{premena datumu na skrateny tvar}
begin
  makedateshort := strng(d,2) + '.' + strng(m,2) + '.' + strng(r,4);
end;

procedure headprogram;                      {zobrazenie celeho nazvu hry}
begin
  settextjustify(centertext,toptext);
  settextstyle(triplexfont,horizdir,4);
  if gd = ega then setusercharsize(5,5,5,6);
  outtextxy(320,0,pname + ' ' + pvers + '  ' + pcopy + '  ' + pdate);
end;

procedure headname;                         {zobrazenie nazvu a typu hry}
begin
  headprogram;
  outtextxy(320,40,wtype + pname);
end;

procedure headinfo;                         {uvodna informacia}
begin
  cleardevice;
  setcolor(white);
  headname;
end;

procedure printchar(x,y: integer; b: byte); {zobrazenie znaku}
begin
  if not micro then
    putimage(x * 16,y * 16,img1[b],normalput)
  else
    putimage(x * 8,y * 8,img2[b],normalput);
end;

procedure writechar(x,y: byte; b: byte);    {ulozenie znaku do hracieho pola}
begin
  printchar(x,y,b);
  garden[x,y] := b;
end;

function iskey: boolean;                    {je stlaceny klaves alebo mys?}
begin
  iskey := keypressed or ms and (ms_z > 0);
end;

procedure waitforkey;                       {cakanie na klaves alebo mys}
begin
  repeat
    if ms then mouseget;
  until iskey;
  if ms then
    repeat
      mouseget;
    until ms_z = 0;
  while keypressed do readkey;
end;

procedure screensaver;                      {setric obrazovky}
const
  n = 50;
var
  x,y:   array[1..n] of real;
  xx,yy: array[1..n] of real;
  i,j:   integer;
  r:     real;

  procedure newstar;
  var
    d,l : real;
  begin
    d := random * 360;
    l := random * 240;
    x[i] := cos(d) * l + 320;
    y[i] := sin(d) * l + 240;
    if (x[i] = 320) and (y[i] = 240) then x[i] := 321;
  end;

  function fnx(x : real) : real;
  begin
    fnx := (x - 320) / r;
  end;

  function fny(y : real) : real;
  begin
    fny := (y - 240) / r;
  end;

  function setspeed: longint;
  var
    h,m,s,t,t0: word;
    l:          longint;
  begin
    l := 0;
    gettime(h,m,s,t);
    repeat
      gettime(h,m,s,t0);
    until t <> t0;
    repeat
      gettime(h,m,s,t);
      inc(l);
    until t <> t0;
    setspeed := l;
  end;

begin
  cleardevice;
  r := 4 * setspeed / n;
  for i := 1 to n do
    begin
      x[i] := random(640);
      y[i] := random(480);
      if (x[i] = 320) and (y[i] = 240) then x[i] := 321;
      xx[i] := fnx(x[i]);
      yy[i] := fny(x[i]);
      putpixel(trunc(x[i]),trunc(y[i]),white);
    end;
  repeat
    for i := 1 to n do
      begin
        putpixel(trunc(x[i]),trunc(y[i]),black);
        x[i] := x[i] + xx[i];
        y[i] := y[i] + yy[i];
        if (x[i] < 0) or (y[i] < 0) or (x[i] > 639) or (y[i] > 479) then
          newstar;
        xx[i] := fnx(x[i]);
        yy[i] := fny(y[i]);
        putpixel(trunc(x[i]),trunc(y[i]),white);
      end;
    mouseget;
  until iskey or ms and ((ms_x <> ms_x0) or (ms_y <> ms_y0));
  while keypressed do waitforkey;
end;

procedure setsaver;
begin
  ms_x0 := ms_x;
  ms_y0 := ms_y;
  saver0 := clock;
  saver := false;
end;

procedure testsaver;
begin
  if ms and ((ms_x <> ms_x0) or (ms_y <> ms_y0) or (ms_z > 0)) then
    setsaver
  else
    begin
      saver1 := clock;
      if saver1 < saver0 then inc(saver1,1572480);
      if saver1 - saver0 >= 1092 then
        begin
          if ms then mousehide;
          screensaver;
          if ms then mouseshow;
          ms_z := 0;
          saver := true;
        end;
    end;
end;

procedure statistics(x: byte);
var
  i,j,k,l: byte;
  r,s:     real;
begin
  statcomp(x);
  headinfo;
  settextstyle(smallfont,horizdir,6);
  if gd = ega then setusercharsize(5,3,5,4);
  settextjustify(centertext,toptext);
  setcolor(yellow);
  case x of
    0: outtextxy(320,100,'tatistika za dnen de');
    1: outtextxy(320,100,'tatistika za poslednch 24 hodn');
    2: outtextxy(320,100,'tatistika za uplynul tde');
    3: outtextxy(320,100,'tatistika za uplynulch 30 dn');
  end;
  settextjustify(lefttext,toptext);
  setcolor(lightgreen);
  outtextxy(80,130,'.');
  outtextxy(120,130,'Meno');
  outtextxy(430,130,'Priemer');
  outtextxy(510,130,'Hier');
  setcolor(lightcyan);
  l := 1;
  for i := 1 to 15 do
    begin
      s := -1;
      for j := 1 to pmax do
        if pg[j] > 0 then
          begin
            r := pw[j] / pg[j];
            if r > s then
              begin
                k := j;
                s := r;
              end;
          end;
      if pg[k] > 0 then
        begin
          outtextxy(80,130 + i * 20,strng(i,2) + '.');
          outtextxy(120,130 + i * 20,pn[k]);
          outtextxy(430,130 + i * 20,strngr(pw[k] / pg[k],7,2));
          outtextxy(510,130 + i * 20,strng(pg[k],4));
          pg[k] := 0;
        end;
    end;
  setcolor(white);
  settextjustify(centertext,bottomtext);
  outtextxy(320,475,'Stla klves alebo tlatko na myi.');
  waitforkey;
end;

procedure showtop;
var
  i,m,m0,n: shortint;
  dt:       datetime;
  c:        char;
  esc:      boolean;
begin
  headinfo;
  settextstyle(smallfont,horizdir,6);
  settextjustify(centertext,toptext);
  setcolor(yellow);
  outtextxy(320,100,'Tabuka najlepch ' + strng(tmax,0) + ' rekordov.');
  settextjustify(lefttext,toptext);
  setcolor(lightgreen);
  outtextxy(35,130,'.');
  outtextxy(75,130,'Meno');
  outtextxy(375,130,'Dka');
  outtextxy(445,130,'Dtum');
  outtextxy(555,130,'as');
  setfillstyle(solidfill,black);
  n := 0;
  while (n < tmax) and (top[micro,n + 1].num > 0) do inc(n);
  esc := false;
  m := 1;
  repeat
    settextjustify(lefttext,toptext);
    for i := 0 to 14 do
      if top[micro,m + i].num > 0 then
        with top[micro,m + i] do
          begin
            if (topmic = micro) and (m + i = topact) then
              setcolor(lightmagenta)
            else
              setcolor(lightcyan);
            bar(35,154 + i * 20,604,168 + i * 20);
            outtextxy(35,150 + i * 20,strng(m + i,2) + '.');
            outtextxy(75,150 + i * 20,pn[num]);
            outtextxy(385,150 + i * 20,strng(len,4));
            unpacktime(time,dt);
            with dt do
              begin
                outtextxy(445,150 + i * 20,makedateshort(day,month,year));
                outtextxy(555,150 + i * 20,maketimehm(hour,min));
              end;
          end;
    setcolor(white);
    settextjustify(centertext,bottomtext);
    outtextxy(320,475,
      'Pohyb pkami, PgUp, PgDn, Home, End, sp Esc, Enter alebo my.');
    m0 := m;
    while keypressed do readkey;
    repeat
      if ms then
        begin
          mouseget;
          if ms_z > 0 then esc := true;
        end;
      if not esc and keypressed then
        begin
          c := readkey;
          case c of
            #27,#13: esc := true;
            #0:
              begin
                c := readkey;
                case c of
                  #72: dec(m);
                  #80: inc(m);
                  #73: dec(m,14);
                  #81: inc(m,14);
                  #71: m := 1;
                  #79: m := n - 14;
                end;
                if m + 14 > n then m := n - 14;
                if m < 1 then m := 1;
              end;
          end;
        end;
    until esc or (m <> m0);
  until esc;
end;

procedure info;                             {informacie}
var
  f: text;
  s: string;
  i: byte;
  j: integer;
  b: boolean;
begin
  cleardevice;
  setcolor(white);
  headprogram;
  settextstyle(smallfont,horizdir,5);
  if gd = ega then setusercharsize(8,6,8,8);
  settextjustify(lefttext,toptext);
  assign(f,dir + '\' + fhelp);
  reset(f);
  j := 60;
  while not eof(f) do
    begin
      readln(f,s);
      for i := 1 to length(s) do s[i] := chr(byte(s[i]) xor 255);
      outtextxy(0,j,s);
      j := j + textheight(s);
    end;
  close(f);
  b := micro;
  micro := false;
  for i := 1 to 5 do printchar(0,13 + i * 2,i);
  micro := b;
  outtextxy(32,15 * 16,'hlavika');
  outtextxy(32,17 * 16,'lnok tela');
  outtextxy(32,19 * 16,'plot');
  outtextxy(32,21 * 16,'jed');
  outtextxy(32,23 * 16,'kapustika');
  settextstyle(smallfont,horizdir,6);
  if gd = ega then setusercharsize(5,3,5,4);
  settextjustify(centertext,bottomtext);
  outtextxy(320,475,'Stla klves alebo tlatko na myi.');
  waitforkey;
end;

procedure programming;                      {informacie o programovani}
var
  gd,gm:  integer;
  rgbpal: array[0..255] of trgbpal;
  t1:     ttextchange;
  t2:     ttextchange;
  t3:     ttextchange;
  i:      byte;
begin
  if vesa then
    begin
      gd := svga;
      gm := 2;
      closegraph;
      initgraph(gd,gm,dir);
      setaspectratio(10000,10000);
    end;
  cleardevice;
  repeat
    for i := 8 to 15 do setrgbpal(getpal256(i),0,0,0);
    milsoftlogo(rgbpal,320,120);
    fadepal(rgbpal,8,15,30);
    if keypressed then break;
    inittextchange(t1,300,1,4,8,4,30,21,63,21);
    inittextchange(t2,350,2,4,8,5,30,21,63,63);
    inittextchange(t3,400,3,4,8,2,30,63,21,63);
    textchange(t1,'Projekt');
    textchange(t2,'Milo abk');
    textchange(t3,'na motvy hry WURMI pre potae Sharp MZ-800');
    if keydelay(2000) then break;
    textchange(t3,'');
    textchange(t2,'');
    textchange(t1,'Npady');
    textchange(t2,'Lucia Majtanov');
    textchange(t3,'premenovanie hrov');
    if keydelay(2000) then break;
    textchange(t3,'vber hra klvesnicou pomocou jeho sla');
    if keydelay(2000) then break;
    textchange(t3,'otoenie do protismeru pri nulovej dke');
    if keydelay(2000) then break;
    textchange(t3,'');
    textchange(t2,'Bohumil Tth');
    textchange(t3,'hesl');
    if keydelay(2000) then break;
    textchange(t3,'pri zmene typu hry sa nastav ten ist hr');
    if keydelay(2000) then break;
    textchange(t3,'');
    textchange(t2,'Martin Kapsa');
    textchange(t3,'tatistika');
    if keydelay(2000) then break;
    textchange(t3,'');
    textchange(t2,'');
    textchange(t1,'Pripomienky');
    textchange(t2,'Peter Jankus');
    textchange(t3,'doplnenie vypnutia zvuku');
    if keydelay(2000) then break;
    textchange(t3,'');
    textchange(t2,'Lucia Majtanov');
    textchange(t3,'presn kontrola potu prekok v hre Micro');
    if keydelay(2000) then break;
    textchange(t3,'pri zmene typu hry netreba znova zada heslo');
    if keydelay(2000) then break;
    textchange(t3,'');
    textchange(t2,'Radoslav Egyd');
    textchange(t3,'vylepenie stlania tlatok');
    if keydelay(2000) then break;
    textchange(t3,'odhalenie optovnho zobrazenia tatistiky');
    if keydelay(2000) then break;
    textchange(t3,'');
    textchange(t2,'');
    textchange(t1,'Njdenie chb');
    textchange(t2,'Radoslav Egyd');
    textchange(t3,'chybn dka pri ran vlastnho tela');
    if keydelay(2000) then break;
    textchange(t3,'');
    textchange(t2,'Bohumil Tth');
    textchange(t3,'nesprvne odpotavanie asu');
    if keydelay(2000) then break;
    textchange(t3,'chybn zobrazenie textov po vypnut zvuku');
    if keydelay(2000) then break;
    textchange(t3,'odhalenie vymenench funkci Heslo a Zvuk');
    if keydelay(2000) then break;
    textchange(t3,'');
    textchange(t2,'');
    textchange(t1,'Jazyk');
    textchange(t2,'Turbo Pascal 7.0');
    if keydelay(2000) then break;
    textchange(t2,'');
    textchange(t1,'Programtor');
    textchange(t2,'Milo abk');
    textchange(t3,'Wurmi 3.0');
    if keydelay(2000) then break;
    textchange(t3,'');
    textchange(t2,'');
    textchange(t1,'Betatesteri');
    textchange(t2,'Radoslav Egyd');
    if keydelay(2000) then break;
    textchange(t2,'Bohumil Tth');
    if keydelay(2000) then break;
    textchange(t2,'Lucia Majtanov');
    if keydelay(2000) then break;
    textchange(t2,'Frantiek Gorilk');
    if keydelay(2000) then break;
    textchange(t2,'Martin Kapsa');
    if keydelay(2000) then break;
    textchange(t2,'Peter Jankus');
    if keydelay(2000) then break;
    textchange(t2,'2. skupina 2.PM');
    if keydelay(2000) then break;
    textchange(t2,'internt SPCH');
    if keydelay(2000) then break;
    textchange(t2,'');
    textchange(t1,'Upozornenie');
    textchange(t2,'Wurmi spsobuje zvislos.');
    textchange(t3,'Peter Jankus');
    if keydelay(2000) then break;
    textchange(t3,'');
    textchange(t2,'');
    textchange(t1,'(C) Milsoft');
    textchange(t2,'Milo abk');
    textchange(t3,pdate0);
    if keypressed then break;
    for i := 8 to 15 do rgbtopal(rgbpal,i,0,0,0);
    fadepal(rgbpal,8,15,30);
    clearlogo(320,120);;
    if keypressed then break;
    if vesa then
      begin
        for i := 128 to 255 do setrgbpal(getpal256(i),0,0,0);
        showautor128(rgbpal,320,20);
        fadepal(rgbpal,128,255,30);
      end
    else
      begin
        for i := 8 to 15 do setrgbpal(getpal(i),0,0,0);
        showautorbw(rgbpal,320,20);
        fadepal(rgbpal,8,15,30);
      end;
    if keypressed then break;
    repeat until keypressed;
    while keypressed do readkey;
    textchange(t3,'');
    textchange(t2,'');
    textchange(t1,'');
    if keypressed then break;
    if vesa then
      begin
        for i := 128 to 255 do rgbtopal(rgbpal,i,0,0,0);
        fadepal(rgbpal,128,255,30);
      end
    else
      begin
        for i := 8 to 15 do rgbtopal(rgbpal,i,0,0,0);
        fadepal(rgbpal,8,15,30);
      end;
  until true;
  if vesa then
    begin
      gd := vga;
      gm := vgahi;
      closegraph;
      initgraph(gd,gm,dir);
    end;
  initpalette;
end;

procedure play;                             {ovladanie hry}
var
  pa:     byte;                             {poradie hraca}
  wz:     word;                             {chybajuc dlzka do prekonania}
  over:   boolean;                          {koniec hry}
  wl0:    word;                             {pom. premenna pre dlzku}
  wt0:    word;                             {pom. premenna pre cas}
  pa0:    byte;                             {pom. premenna pre poradie}
  wz0:    word;                             {pom. premenna pre chyb. dlzku}
  wzp:    byte;                             {pom. premenna pre chyb. dlzku}
  z0:     byte;                             {pom. premenna pre smer}
  wtr:    real;                             {realny cas hry pre priemer}
  s0,t0:  word;                             {cas poslednej zmeny sekundy}

  procedure pauseproc;                      {stlacenie PAUSE}
  var
    h,m,s,t: word;
    a,b:     word;
  begin
    gettime(h,m,s,t);
    if s < s0 then inc(s,60);
    a := (s * 100 + t) - (s0 * 100 + t0);
    repeat
    until keypressed;
    gettime(h,m,s,t);
    b := (s * 100 + t);
    if a > b then inc(b,6000);
    dec(b,a);
    s0 := b div 100;
    t0 := b mod 100;
    pauseflag := false;
  end;

  procedure writepa;                        {zobrazenie poradia}
  begin
    while (pa > 1) and (wl > pl[pa - 1]) do dec(pa);
    if pa0 <> pa then
      begin
        if pa0 <> pc + 1 then
          begin
            setcolor(black);
            outtextxy(576,280,strng(pa0,1) + '.');
          end;
        setcolor(white);
        outtextxy(576,280,strng(pa,1) + '.');
        pa0 := pa;
      end;
    if wl > pl[ps] then pl[ps] := wl;
    if wl > pl0 then pl0 := wl;
  end;

  procedure writewz;                        {zobrazenie chybajucej dlzky}
  begin
    if pa > 1 then
      wz := pl[pa - 1] - wl + 1
    else
      wz := 0;
    if wz0 <> wz then
      begin
        settextstyle(triplexfont,horizdir,size);
        if wz0 <> 65535 then
          begin
            setcolor(black);
            outtextxy(576,400,strng(wz0,1));
          end;
        setcolor(lightgray);
        outtextxy(576,400,strng(wz,1));
        wz0 := wz;
      end;
  end;

  procedure writewl;                        {zobrazenie dlzky}
  begin
    if wl0 <> wl then
      begin
        settextstyle(triplexfont,horizdir,size);
        settextjustify(centertext,toptext);
        if wl0 <> 65535 then
          begin
            setcolor(black);
            outtextxy(576,40,strng(wl0,1));
          end;
        setcolor(clen);
        outtextxy(576,40,strng(wl,1));
        wl0 := wl;
        writepa;
        writewz;
      end;
  end;

  procedure writewt;                        {zobrazenie casu}
  var
    a: byte;
  begin
    if wt0 <> wt then
      begin
        settextstyle(triplexfont,horizdir,size);
        settextjustify(centertext,toptext);
        if wt0 <> 65535 then
          begin
            setcolor(black);
            outtextxy(576,160,maketime(wt0));
          end;
        if wt > 30 then
          a := 63
        else
          a := 63 * wt div 30;
        setrgbpal(pal.colors[ctim],63,a,a);
        setcolor(ctim);
        outtextxy(576,160,maketime(wt));
        wt0 := wt;
        if wt = 0 then over := true;
      end;
  end;

  procedure makegarden;                     {zobrazenie zahrady}
  var
    x,y: byte;
    i,j: word;
  begin
    for i := 0 to maxx do
      for j := 0 to maxy do
        garden[i,j] := free;
    for i := 0 to maxx do
      begin
         writechar(i,0,wall);
         writechar(i,maxy,wall);
      end;
    for i := 0 to maxy do
      begin
        writechar(0,i,wall);
        writechar(maxx,i,wall);
      end;
    for i := 1 to ndie do
      begin
        x := random(maxx - 2) + 1;
        y := random(maxy - 2) + 1;
        writechar(x,y,die);
        writechar(x + 1,y,die);
        writechar(x,y + 1,die);
        writechar(x + 1,y + 1,die);
      end;
    for i := 1 to neat do
      begin
        repeat
          x := random(maxx - 1) + 1;
          y := random(maxy - 1) + 1;
        until garden[x,y] = free;
        writechar(x,y,eat);
      end;
    repeat
      x := random(maxx - 1) + 1;
      y := random(maxy - 1) + 1;
    until garden[x,y] = free;
    pl0 := 0;
    wl0 := 65535;
    wt0 := 65535;
    pa0 := ps + 1;
    wz0 := 65535;
    if ps > 1 then
      wzp := ps - 1
    else
      wzp := 1;
    while (wzp > 1) and (pl[wzp] = 0) do dec(wzp);
    z0 := 0;
    wx[0] := x;
    wy[0] := y;
    w0 := 0;
    w1 := 0;
    wl := 0;
    wt := wtime;
    pa := ps;
    wz := pl[ps];
    writechar(x,y,head);
    settextstyle(triplexfont,horizdir,4);
    settextjustify(centertext,toptext);
    setcolor(cyan);
    outtextxy(576,0,'Dka');
    outtextxy(576,120,'as');
    outtextxy(576,240,'Poradie');
    outtextxy(576,360,'Chba');
    writewl;
    writewt;
    over := false;
  end;

  procedure changepalette;                  {zmena farby dlzky}
  var
    a:       byte;
    r,r1,r2: real;
  begin
    if (wl = 0) or (wtr = 0) or (pl[ps] = 0) then
      begin
        r1 := 1;
        r2 := 1;
      end
    else
      begin
        r1 := (wl / wtr);
        r2 := (pl[ps] / wtime);
      end;
    if r1 > r2 then
      begin
        r := r1 / r2;
        if r > 1.2 then r := 1.2;
        a := trunc(315 * (1.2 - r));
        setrgbpal(pal.colors[clen],a,63,a);
      end
    else
      begin
        r := r2 / r1;
        if r > 1.2 then r := 1.2;
        a := trunc(315 * (1.2 - r));
        setrgbpal(pal.colors[clen],63,a,a)
      end;
  end;

  procedure writewurmi(z: byte);            {pohyb Wurmiho}
  var
    x,y:     shortint;
    h,m,s,t: word;
    a,b:     word;
  begin
    z0 := z;
    case z of
      1,2: x := 0;
      3:   x := -1;
      4:   x := 1;
    end;
    case z of
      1:   y := -1;
      2:   y := 1;
      3,4: y := 0;
    end;
    writechar(wx[w0],wy[w0],free);
    if w1 <> w0 then writechar(wx[w0],wy[w0],body);
    x := wx[w0] + x;
    y := wy[w0] + y;
    inc(w0);
    if w0 > wmax then w0 := 0;
    wx[w0] := x;
    wy[w0] := y;
    case garden[x,y] of
      wall,die:
        begin
          writechar(x,y,free);
          writechar(wx[w1],wy[w1],free);
          over := true;
        end;
      eat:
        begin
          writechar(x,y,free);
          wl := wl + 1;
          writewl;
          snd(250,20);
          repeat
            x := random(maxx - 1) + 1;
            y := random(maxy - 1) + 1;
          until (garden[x,y] = free) and ((wx[w0] <> x) or (wy[w0] <> y));
          writechar(x,y,eat);
        end;
      free,body:
        begin
          writechar(wx[w1],wy[w1],free);
          inc(w1);
          if w1 > wmax then w1 := 0;
          printchar(wx[w0],wy[w0],head);
          if garden[x,y] = body then
            begin
              printchar(wx[w0],wy[w0],head);
              gettime(h,m,s,t);
              if s < s0 then inc(s,60);
              a := (s * 100 + t) - (s0 * 100 + t0);
              repeat
                writechar(wx[w1],wy[w1],free);
                inc(w1);
                if w1 > wmax then w1 := 0;
                dec(wl);
                writewl;
                changepalette;
                snd(500,20);
              until garden[x,y] <> body;
              gettime(h,m,s,t);
              b := (s * 100 + t);
              if a > b then inc(b,6000);
              dec(b,a);
              s0 := b div 100;
              t0 := b mod 100;
            end;
        end;
    end;
    writechar(wx[w0],wy[w0],head);
  end;

var
  h,m,s,t: word;
  t1:      word;
  c1,c2:   char;
  z:       byte;
  i,j:     byte;
  move:    boolean;
  mx,my:   real;
  again:   boolean;
begin
  pauseflag := false;
  cleardevice;
  setrgbpal(pal.colors[clen],63,63,63);
  setrgbpal(pal.colors[ctim],63,63,63);
  makegarden;
  s0 := 60;
  wtr := 0;
  z := 0;
  repeat
    if pauseflag then pauseproc;
    again := true;
    while again and keypressed do
      begin
        c1 := readkey;
        if c1 = #0 then c2 := readkey;
        if c1 = #9 then sndflg := not sndflg;
        if c1 = #27 then again := false;
        if upcase(c1) = 'P' then pauseproc;
        if c1 = #0 then
          begin
            again := false;
            case c2 of
              #72: if not (z0 in [1,2]) then z := 1 else again := true;
              #80: if not (z0 in [1,2]) then z := 2 else again := true;
              #75: if not (z0 in [3,4]) then z := 3 else again := true;
              #77: if not (z0 in [3,4]) then z := 4 else again := true;
            else
              again := true;
            end;
            if wl = 0 then
              begin
                again := false;
                case c2 of
                  #72: if z0 <> 1 then z := 1 else again := true;
                  #80: if z0 <> 2 then z := 2 else again := true;
                  #75: if z0 <> 3 then z := 3 else again := true;
                  #77: if z0 <> 4 then z := 4 else again := true;
                else
                  again := true;
                end;
              end;
          end;
      end;
    if z > 0 then
      begin
        move := true;
        if s0 = 60 then
          begin
            gettime(h,m,s0,t0);
            t1 := t0;
          end;
        writewurmi(z);
        gettime(h,m,s,t);
        if t >= t1 then
          wtr := wtr + (t - t1) / 100
        else
          wtr := wtr + (t + 100 - t1) / 100;
        t1 := t;
        changepalette;
        for i := 1 to 10 do snd(random(30) + 50,20);
        gettime(h,m,s,t);
        if s < s0 then inc(s, 60);
        if s * 100 + t >= s0 * 100 + t0 + 100 then
          begin
            dec(wt);
            writewt;
            if t < t0 then dec(s);
            s0 := s mod 60;
          end;
      end;
  until over or (c1 = #27) ;
  if over then
    for i := 1 to 20 do
      begin
        printchar(wx[w0],wy[w0],free);
        snd(1000 - i * 50,50);
        printchar(wx[w0],wy[w0],head);
        snd(1025 - i * 50,50);
        if keypressed and (readkey = #27) then break;
      end;
  initpalette;
end;

procedure menu;                             {hlavne menu}
const
  xx1 = 20;                                 {suradnice tabulky hracov}
  yy1 = 150;
  xx2 = xx1 + 389;
  yy2 = yy1 + 149;
  xm1 = 450;                                {suradnice tlacitok v menu}
  ym1 = 120;
  xm2 = 180;                                {velkost tlacitok v menu}
  ym2 = 20;
  zm  = 30;                                 {vzdialenost tlacitok}
type
  tcmd  = (cmd0,cmnew,cmren,cmdel,cmpass,cmsnd,cmsize,cmstat,cmtop,cmplay,
           cminfo,cmexit,
           cmstat1,cmstat2,cmstat3,cmstat4,cmstat5,
           cmprg,cmup,cmdown,cmpgup,cmpgdn,cmhome,cmend);
  tmenu = record
    a,b:  tcmd;                             {prvy a posledny prikaz v menu}
    name: string[15];
    back: byte;
  end;
const
  cmdc    = cmstat5;                        {posledne tlacitko}
  menumax = 1;                              {pocet menu}
  sndon   = 'Zvuk vyp-Tab';
  sndoff  = 'Zvuk zap-Tab';
  cmds: array[cmnew..cmdc] of string[15] =  {texty na tlacitkach}
    ('Nov-Insert','Premenova-BS','Zmaza-Delete','Heslo-*',
     '','Vekos-Space','tatistika-S','Najlep-F10','tart-Enter',
     'Info-F1','Koniec-Esc',
     'Dnes-Alt+F2','De-Ctrl+F2','Tde-F2','Mesiac-Shift+F2','Sp-Esc');
  menus: array[0..menumax] of tmenu =       {zoznam menu}
    ((a: cmnew;   b: cmexit;  name: 'Hlavn menu'; back: 255),
     (a: cmstat1; b: cmstat5; name: 'tatistika';  back: 0));
var
  x1,x2,y1,y2: integer;                     {suradnice tlacitok}
  z:           integer;                     {farba tlacitka}
  h1,s1:       word;                        {zobrazeny cas}
  hh,mm,ss,tt: word;                        {aktualny cas}
  xtime:       boolean;                     {zobrazit cas ano/nie}
  menu:        byte;                        {aktualne menu}
  xmnu,xlst:   boolean;                     {zmena menu, zoznamu hracov}

  procedure select(ps: byte; b: boolean);   {oznacenie hraca}
  var
    i: byte;
  begin
    i := ps - px + 1;
    if b then
      setfillstyle(solidfill,red)
    else
      setfillstyle(solidfill,brown);
    bar(xx1,yy1 - 15 + i * 15,xx2,yy1 - 1 + i * 15);
    if pc > 0 then
      begin
        if i <= pc then
          begin
            settextstyle(smallfont,horizdir,6);
            if gd = ega then setusercharsize(5,3,5,4);
            settextjustify(lefttext,toptext);
            setcolor(cyan);
            outtextxy(xx1,yy1 - 19 + i * 15,strng(ps,2) + '.');
            outtextxy(xx1 + 40,yy1 - 19 + i * 15,pn[ps]);
            outtextxy(xx1 + 350,yy1 - 19 + i * 15,strng(pl[ps],4));
          end;
      end;
  end;

  procedure showplayers;                    {zobrazenie hracov}
  var
    i: byte;
  begin
    if not (ps in [0,px..px + 9]) then
      if ps < px then
        px := ps
      else
        px := ps - 9;
    if (pc > 9) and (px + 9 > pc) then px := pc - 9;
    if ms then mousehide;
    for i := px to px + 9 do select(i,i = ps);
    if ms then mouseshow;
    xlst := false;
  end;

  procedure compute(i: tcmd);               {vypocet sur. tlacitok}
  begin
    if i in [menus[menu].a..menus[menu].b] then
      begin
        x1 := xm1;
        x2 := x1 + xm2;
        y1 := yq(ym1 + (byte(i) - byte(menus[menu].a) + 1) * zm);
        y2 := y1 + ym2;
      end;
    case i of
      cmnew,cmplay: z := lightgreen;
      cmdel,cmexit: z := lightred;
    else
      z := yellow;
    end;
    if i = menus[menu].b then z := lightred;
    if (pc = 0) and (i in [cmdel,cmren,cmpass,cmstat,cmtop,cmplay,
      cmstat1..cmstat4]) or (pc = pmax) and (i = cmnew) then z := darkgray;
  end;

  procedure showmenu;                       {zobrazenie podmenu}
  var
    i: tcmd;
  begin
    setfillstyle(solidfill,black);
    settextstyle(smallfont,horizdir,6);
    if gd = ega then setusercharsize(5,3,5,4);
    settextjustify(centertext,toptext);
    setcolor(white);
    if ms then mousehide;
    bar(xm1,ym1,xm1 + xm2,479);
    outtextxy(xm1 + xm2 div 2,ym1 - 3,menus[menu].name);
    for i := menus[menu].a to menus[menu].b do
      begin
        compute(i);
        buttonoff(x1,y1,x2,y2,cmds[i],z);
      end;
    if ms then mouseshow;
    xmnu := false;
  end;

  procedure sort;                           {utriedenie hracov}
  var
    i,j,k: byte;
    s:     string[30];
    w:     word;
    p:     string[30];
    x:     byte;
    b:     boolean;
  begin
    b := false;
    for i := 1 to pc do
      begin
        k := i;
        for j := i to pc do if pl[j] > pl[k] then k := j;
        if k > i then
          begin
            if k = ps then
              begin
                ps := i;
                b := true;
              end;
            s := pn[k];
            w := pl[k];
            p := pp[k];
            for j := k - 1 downto i do
              begin
                pn[j + 1] := pn[j];
                pl[j + 1] := pl[j];
                pp[j + 1] := pp[j];
              end;
            pn[i] := s;
            pl[i] := w;
            pp[i] := p;
            statsort(i,k);
            topsort(i,k);
          end;
      end;
    if b then
      if ps < 10 then
        px := 1
      else
        px := ps - 9;
  end;

  procedure showstr(txt: string; col: word);{zobrazenie retazca}
  const
    x1 = 0;
    y1 = 350;
  var
    c: char;
    w: word;
  begin
    settextjustify(lefttext,toptext);
    setfillstyle(solidfill,col);
    w := textwidth(txt);
    if ms then mousehide;
    bar(x1,y1,x1 + w + 39,y1 + 74);
    setcolor(white);
    rectangle(x1 + 3,y1 + 6,x1 + w + 36,y1 + 68);
    rectangle(x1 + 5,y1 + 8,x1 + w + 34,y1 + 66);
    outtextxy(x1 + 20,y1 + 26,txt);
    repeat
      mouseget;
    until ms_z = 0;
    waitforkey;
    setfillstyle(solidfill,black);
    bar(x1,y1,x1 + w + 39,y1 + 74);
    if ms then mouseshow;
  end;

  function delplayer: boolean;              {otazka na vymazanie hraca}
  const
    x1 = 0;
    y1 = 350;
    txt = 'Chce naozaj vymaza tohto hra? [A/N]';
  var
    c: char;
    w: word;
  begin
    xtime := true;
    settextstyle(smallfont,horizdir,6);
    if gd = ega then setusercharsize(5,3,5,4);
    settextjustify(lefttext,toptext);
    setfillstyle(solidfill,red);
    w := textwidth(txt);
    if ms then mousehide;
    bar(x1,y1,x1 + w + 39,y1 + 74);
    setcolor(white);
    rectangle(x1 + 3,y1 + 6,x1 + w + 36,y1 + 68);
    rectangle(x1 + 5,y1 + 8,x1 + w + 34,y1 + 66);
    outtextxy(x1 + 20,y1 + 26,txt);
    repeat
      mouseget;
    until ms_z = 0;
    repeat
      repeat
        mouseget;
      until keypressed or (ms_z > 0);
      if keypressed then
        begin
          c := upcase(readkey);
          if c = #0 then readkey;
        end;
    until (c in ['A','N',#27]) or (ms_z > 0);
    setfillstyle(solidfill,black);
    bar(x1,y1,x1 + w + 39,y1 + 74);
    if ms then mouseshow;
    delplayer := (c = 'A') or (ms_z = 1);
  end;

  procedure readstr(txt: string; shw: boolean;
    var s: string; var canc: boolean);      {nacitanie retazca z ramceka}
  const
    x1 = 0;
    y1 = 350;
  var
    c:   char;
    w,e: word;
    i:   byte;
  begin
    xtime := true;
    s := '';
    settextstyle(smallfont,horizdir,6);
    if gd = ega then setusercharsize(5,3,5,4);
    settextjustify(lefttext,toptext);
    setfillstyle(solidfill,brown);
    w := textwidth(txt);
    if ms then mousehide;
    bar(x1,y1,x1 + w + 359,y1 + 74);
    setcolor(white);
    rectangle(x1 + 3,y1 + 6,x1 + w + 356,y1 + 68);
    rectangle(x1 + 5,y1 + 8,x1 + w + 354,y1 + 66);
    outtextxy(x1 + 20,y1 + 26,txt);
    repeat
      if shw then
        e := textwidth(s)
      else
        e := textwidth('*') * length(s);
      setfillstyle(solidfill,brown);
      bar(x1 + w + 30,y1 + 30,x1 + w + 339,y1 + 44);
      if shw then
        outtextxy(x1 + w + 30,y1 + 26,s)
      else
        begin
          moveto(x1 + w + 30,y1 + 26);
          for i := 1 to length(s) do outtext('*');
        end;
      setfillstyle(solidfill,white);
      bar(x1 + e + w + 30,y1 + 30,x1 + e + w + 39,y1 + 44);
      repeat
        c := getcs;
        if c = #0 then readkey;
        if not (c in [#8,#13,#27]) and (length(s) = 30) then c := #0;
      until c > #0;
      if (c = #8) and (length(s) > 0) then
        s := copy(s,1,length(s) - 1);
      if (c >= #32) and (length(s) < 30) then s := s + c;
    until c in [#13,#27];
    setfillstyle(solidfill,black);
    bar(x1,y1,x1 + w + 359,y1 + 74);
    if ms then mouseshow;
    if c = #27 then s := '';
    canc := c = #27;
  end;

  function checkpassword: boolean;          {zadanie a kontrola hesla}
  var
    s: string;
    b: boolean;
  begin
    if pp[ps] <> '' then
      begin
        checkpassword := false;
        readstr('Heslo:',false,s,b);
        if b then exit;
        if s <> pp[ps] then
          begin
            showstr('Chyba v hesle.',red);
            exit;
          end
        else
          checkpassword := true;
      end
    else
      checkpassword := true;
  end;

  procedure showtime;                       {zobrazenie datumu a casu}
  const
    x1 = 220;
    y1 = 350;
  var
    y,m,d,t: word;                          {datum}
    xdate:   boolean;                       {zobrazit datum a/n}
  begin
    xdate := false;
    gettime(hh,mm,ss,tt);
    if xtime then xdate := true;
    if not xtime and (ss <> s1) then
      begin
        setfillstyle(solidfill,black);
        if ms then mousehide;
        bar(x1 - 120,y1 + 30,x1 + 110,y1 + 74);
        if ms then mouseshow;
        xtime := true;
      end;
    if xtime then
      begin
        setcolor(white);
        settextstyle(triplexfont,horizdir,6);
        if gd = ega then setusercharsize(5,3,5,4);
        settextjustify(centertext,toptext);
        if ms then mousehide;
        outtextxy(x1,y1 + 15,maketimehms(hh,mm,ss));
        if ms then mouseshow;
        xtime := false;
      end;
    if not xdate and (hh < h1) then
      begin
        setfillstyle(solidfill,black);
        if ms then mousehide;
        bar(x1 - 140,y1,x1 + 135,y1 + 29);
        if ms then mouseshow;
        xdate := true;
      end;
    if xdate then
      begin
        settextstyle(smallfont,horizdir,6);
        if gd = ega then setusercharsize(5,3,5,4);
        if ms then mousehide;
        outtextxy(x1,y1,makedate);
        if ms then mouseshow;
      end;
    h1 := hh;
    s1 := ss;
  end;

var
  cmd:         tcmd;                        {vykonavany prikaz}
  cmdi:        tcmd;                        {pocitadlo pre tlacitka}
  h0,m0,s0,t0: word;                        {zaciatocny cas pre vyber}
  ps0:         byte;                        {pom. premenna pre cislo hraca}
  xpass:       boolean;                     {zadat heslo ano/nie}
  s,t:         string;                      {retazce}
  click:       byte;                        {stlacene tlacitko 1-kbd,2-mys}
  cheat:       string[7];                   {retazec pre aktivaciu info}
  i:           byte;
  c:           char;
  b:           boolean;
begin
  if sndflg then
    cmds[cmsnd] := sndoff
  else
    cmds[cmsnd] := sndon;
  xpass := true;
  menu := 0;
  repeat
    cheat := '';
    headinfo;
    cmd := cmd0;
    settextstyle(smallfont,horizdir,6);
    if gd = ega then setusercharsize(5,3,5,4);
    if winver >= 0 then
      begin
        settextjustify(centertext,toptext);
        outtextxy(320,90,'Hru nie je vhodn spa v prostred Windows.');
      end;
    settextjustify(lefttext,toptext);
    setfillstyle(solidfill,brown);
    bar(xx1 - 20,yy1 - 30,xx2 + 20,yy2 + 15);
    rectangle(xx1 - 17,yy1 - 24,xx2 + 17,yy2 + 9);
    rectangle(xx1 - 15,yy1 - 22,xx2 + 15,yy2 + 7);
    outtextxy(xx1,yy1 - 19,'.');
    outtextxy(xx1 + 40,yy1 - 19,'Meno');
    outtextxy(xx1 + 340,yy1 - 19,'Dka');
    xmnu := true;
    xlst := true;
    xtime := true;
    if ms then mouseshow;
    repeat
      h0 := 100;
      repeat
        if xmnu then showmenu;
        if xlst then showplayers;
        while keypressed do readkey;
        setsaver;
        repeat
          showtime;
          if h0 < 100 then
            begin
              gettime(hh,mm,ss,tt);
              if ss < s0 then inc(ss,60);
              if (ss * 100 + tt) - (s0 * 100 + t0) > 200 then h0 := 100;
            end;
          if ms then mouseget;
          testsaver;
        until saver or keypressed or ms and (ms_z <> 0);
        cmd := cmd0;
        click := 0;
        if keypressed then
          begin
            c := readkey;
            if length(cheat) = 7 then cheat := copy(cheat,2,6);
            cheat := cheat + upcase(c);
            if cheat = 'MILSOFT' then cmd := cmprg;
            case upcase(c) of
              #27: cmd := menus[menu].b;
              #8:  cmd := cmren;
              #42: cmd := cmpass;
              #9:  cmd := cmsnd;
              #32: cmd := cmsize;
              #13: cmd := cmplay;
              'S': cmd := cmstat;
              #0:
                begin
                  c := readkey;
                  case c of
                    #82:  cmd := cmnew;
                    #83:  cmd := cmdel;
                    #68:  cmd := cmtop;
                    #59:  cmd := cminfo;
                    #105: cmd := cmstat1;
                    #95:  cmd := cmstat2;
                    #60:  cmd := cmstat3;
                    #85:  cmd := cmstat4;
                    #45:  cmd := cmexit;
                    #72:  cmd := cmup;
                    #80:  cmd := cmdown;
                    #73:  cmd := cmpgup;
                    #81:  cmd := cmpgdn;
                    #71:  cmd := cmhome;
                    #79:  cmd := cmend;
                  end;
                end;
              '0'..'9':
                begin
                  ps0 := ps;
                  if h0 = 100 then
                    begin
                      gettime(h0,m0,s0,t0);
                      ps := byte(c) - 48;
                    end
                  else
                    begin
                      gettime(h0,m0,s0,t0);
                      ps := (ps mod 10) * 10 + (byte(c) - 48);
                      if ps > pc then ps := byte(c) - 48;
                    end;
                  if ps > pc then
                    ps := ps0
                  else
                    if ps <> ps0 then xlst := true;
                end;
            end;
            if cmd > cmd0 then click := 1;
          end;
        if ms and (ms_z <> 0) then
          begin
            if (ms_x >= xx1) and (ms_x <= xx2) and
              (ms_y >= yy1 - 15) and (ms_y <= yy2 + 15) then
              begin
                h0 := 100;
                ps0 := (ms_y - yy1 + 15) div 15;
                if ps0 = 0 then cmd := cmup;
                if ps0 = 11 then cmd := cmdown;
                if cmd > cmd0 then click := 1;
                if (ps0 in [1..10]) and (ps0 <= pc) then
                  begin
                    ps0 := px - 1 + ps0;
                    if ps <> ps0 then
                      begin
                        if ms then mousehide;
                        select(ps,false);
                        select(ps0,true);
                        if ms then mouseshow;
                        ps := ps0;
                      end;
                  end;
              end
            else
              begin
                for cmdi := menus[menu].a to menus[menu].b do
                  begin
                    compute(cmdi);
                    if buttonover(x1,y1,x2,y2,ms_x,ms_y) then
                      begin
                        cmd := cmdi;
                        click := 2;
                      end;
                  end;
              end;
          end;
        compute(cmd);
        if z = darkgray then cmd := cmd0;
        if cmd in [menus[menu].a..menus[menu].b] then
          begin
            if cmd > cmd0 then
              begin
                if ms then mousehide;
                buttonon(x1,y1,x2,y2,cmds[cmd]);
                if ms then mouseshow;
                if click = 1 then
                  delay(50)
                else
                  begin
                    repeat
                      showtime;
                      mouseget;
                      if not buttonover(x1,y1,x2,y2,ms_x,ms_y) then
                        click := 0;
                    until (ms_z = 0) or (click = 0);
                  end;
                if ms then mousehide;
                buttonoff(x1,y1,x2,y2,cmds[cmd],z);
                if ms then mouseshow;
              end;
          end;
        if click = 0 then cmd := cmd0;
      until saver or (cmd > cmd0);
      if cmd <= cmdc then snd(5000,10);
      if cmd = menus[menu].b then
        begin
          menu := menus[menu].back;
          if menu = 255 then
            cmd := cmexit
          else
            begin
              cmd := cmd0;
              xmnu := true;
            end;
        end;
      case cmd of
        cmup:
          if ps > 1 then
            begin
              ps := ps - 1;
              xlst := true;
            end;
        cmdown:
          if ps < pc then
            begin
              ps := ps + 1;
              xlst := true;
            end;
        cmpgup:
          if ps > 1 then
            begin
              if ps > 10 then
                ps := ps - 10
              else
                ps := 1;
              xlst := true;
            end;
        cmpgdn:
          if ps < pc then
            begin
              if ps < pc - 9 then
                ps := ps + 10
              else
                ps := pc;
              xlst := true;
            end;
        cmhome:
          if ps > 1 then
            begin
              ps := 1;
              xlst := true;
            end;
        cmend:
          if ps < pc then
            begin
              ps := pc;
              xlst := true;
            end;
        cmnew:
          begin
            cmd := cmd0;
            readstr('Meno:',true,s,b);
            if s <> '' then
              begin
                inc(pc);
                pn[pc] := s;
                pl[pc] := 0;
                pp[pc] := '';
                ps := pc;
                if (menu = 0) and (pc in [1,99]) then xmnu := true;
                xlst := true;
              end;
          end;
        cmren:
          repeat
            cmd := cmd0;
            if not checkpassword then break;
            readstr('Meno:',true,s,b);
            if s <> '' then pn[ps] := s;
            xlst := true;
          until true;
        cmdel:
          repeat
            cmd := cmd0;
            if not checkpassword then break;
            if delplayer then
              begin
                if ps < pc then
                  for i := ps to pc - 1 do
                    begin
                      pn[i] := pn[i + 1];
                      pl[i] := pl[i + 1];
                      pp[i] := pp[i + 1];
                    end;
                statdel(ps);
                topdel(ps);
                if ps = pc then ps := pc - 1;
                dec(pc);
                if pc = 0 then menu := 0;
                if (menu = 0) and (pc in [0,98]) then xmnu := true;
                xlst := true;
              end;
          until true;
        cmpass:
          repeat
            cmd := cmd0;
            if not checkpassword then break;
            readstr('Nov:',false,s,b);
            if b then break;
            readstr('Kontrola:',false,t,b);
            if b then break;
            if s <> t then
              begin
                showstr('Nebolo zadan to ist heslo.',red);
                break;
              end;
            if s <> '' then
              begin
                if pp[ps] = '' then
                  t := 'Heslo bolo pridan.'
                else
                  t := 'Heslo bolo zmenen.';
              end
            else
              t := 'Heslo bolo zruen.';
            pp[ps] := s;
            showstr(t,brown);
            xpass := true;
          until true;
        cmsnd:
          begin
            cmd := cmd0;
            sndflg := not sndflg;
            if sndflg then
              cmds[cmsnd] := sndoff
            else
              cmds[cmsnd] := sndon;
            compute(cmsnd);
            if ms then mousehide;
            buttonoff(x1,y1,x2,y2,cmds[cmsnd],z);
            if ms then mouseshow;
          end;
        cmsize:
          begin
            cmd := cmd0;
            if pc > 0 then
              begin
                s := pn[ps];
                t := pp[ps];
              end
            else
              s := '';
            writeplayers;
            setcolor(black);
            if ms then mousehide;
            headname;
            microwurmi(not micro);
            setcolor(white);
            headname;
            if ms then mouseshow;
            for i := 1 to pc do if pn[i] = s then ps := i;
            if (pc > 0) and (pn[ps] = s) and (pp[ps] <> t) then xpass := true;
            if ps > 9 then px := ps - 9;
            if pc = 0 then menu := 0;
            if menu = 0 then xmnu := true;
            xlst := true;
          end;
        cmstat:
          begin
            cmd := cmd0;
            menu := 1;
            xmnu := true;
          end;
        cmplay: if xpass and not checkpassword then cmd := cmd0;
      end;
      if cmd in [cmup..cmend] then
        begin
          cmd := cmd0;
          xpass := true;
        end;
    until saver or (cmd > cmd0);
  if ms then mousehide;
    case cmd of
      cmtop: showtop;
      cmplay:
        begin
          play;
          sort;
          xpass := false;
          statadd(micro,ps,pl0);
          topadd(micro,ps,pl0);
        end;
      cminfo: info;
      cmstat1..cmstat4: statistics(byte(cmd) - byte(cmstat1));
      cmprg: if gd = vga then programming;
    end;
  until cmd = cmexit;
end;

procedure done;                             {ukoncenie}

  procedure writeinifile;                   {ulozenie konfiguracie}
  const
    boolint: array[boolean] of char = ('0','1');
  begin
    rewriteini(dir + '\' + fini);
    writeblockrem('Main','hlavna konfig.');
    writevaluerem('Sound',boolint[sndflg],'zvuk');
    writevaluerem('Micro',boolint[micro],'hra Micro');
    closeini;
  end;

begin
  writeplayers;
  writestatistics;
  writetop;
  writeinifile;
  donepalette;
  closegraph;
end;


begin
  init;
  menu;
  done;
end.
