{**********************************************************}
{*                                                        *}
{*   Nazov:  Mouse                                        *}
{*   Datum:  17. 8.2001                                   *}
{*   Start:  17. 8.2001                                   *}
{*   Jazyk:  Turbo Pacal 7.0                              *}
{*   Autor:  Milsoft                                      *}
{*   Typ:    Unit                                         *}
{*                                                        *}
{**********************************************************}
                                                                                {
{$F-,O-,A+,G+,R-,S-,I-,Q-,V+,B-,X+,T+,P-,D-,L-,Y-,N-,E-}

unit mouse;

interface
var
  ms_x,ms_y,ms_z: integer;
function mouseinit: boolean;
procedure mouseshow;
procedure mousehide;
procedure mouseget;
procedure mouseset(x,y: integer);

implementation

function mouseinit: boolean; assembler;
asm
  mov ax,0
  int $33
end;

procedure mouseshow; assembler;
asm
  mov ax,1
  int $33
end;

procedure mousehide; assembler;
asm
  mov ax,2
  int $33
end;

procedure mouseget; assembler;
asm
  mov ax,3
  int $33
  mov ms_x,cx
  mov ms_y,dx
  mov ms_z,bx
end;

procedure mouseset(x, y: integer); assembler;
asm
  mov ax,4
  mov cx,[x]
  mov dx,[y]
  int $33
end;

procedure mouserange(x1, y1, x2, y2: integer); assembler;
asm
  mov ax,7
  mov cx,x1
  mov dx,x2
  int $33
  mov ax,8
  mov cx,y1
  mov dx,y2
  int $33
end;

end.
